/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.npc.MRemoveNpcsFromGS
 *  fire.pb.fushi.Module
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.MapConfig
 *  fire.pb.npc.SNpcShare
 *  fire.pb.scene.config.NpcDesc
 *  fire.pb.scene.manager.PickUpManager
 *  fire.pb.scene.manager.SceneNpcManager
 *  fire.pb.scene.movable.Body
 *  fire.pb.scene.movable.NPC
 *  fire.pb.scene.movable.Pickup
 *  fire.pb.scene.movable.Role
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.scene.sPos.Position
 *  fire.pb.scene.sPos.ScreenPos
 *  gnet.link.Onlines
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 */
package fire.pb.scene;

import fire.msp.npc.MRemoveNpcsFromGS;
import fire.pb.fushi.Module;
import fire.pb.main.ConfigManager;
import fire.pb.map.MapConfig;
import fire.pb.npc.SNpcShare;
import fire.pb.scene.BlockInfo;
import fire.pb.scene.GotoInfo;
import fire.pb.scene.MapInfo;
import fire.pb.scene.MapUtil;
import fire.pb.scene.SceneClient;
import fire.pb.scene.SceneManager;
import fire.pb.scene.Screen;
import fire.pb.scene.config.NpcDesc;
import fire.pb.scene.manager.PickUpManager;
import fire.pb.scene.manager.SceneNpcManager;
import fire.pb.scene.movable.Body;
import fire.pb.scene.movable.NPC;
import fire.pb.scene.movable.Pickup;
import fire.pb.scene.movable.Role;
import fire.pb.scene.sPos.GridPos;
import fire.pb.scene.sPos.Position;
import fire.pb.scene.sPos.ScreenPos;
import gnet.link.Onlines;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import mkio.Protocol;
import org.apache.log4j.Logger;

public abstract class Scene {
    public static final Logger LOG = Logger.getLogger((String)"MAPMAIN");
    private long sceneId = 0L;
    private String name = "";
    private MapInfo mapInfo = null;
    private int roleNum = 0;
    private MapConfig mapcfg;
    protected final Map<Integer, Screen> screens = new ConcurrentHashMap<Integer, Screen>();
    public static final int VISIBLE_ALL = 0;
    public static final int VISIBLE_SINGLE = 1;
    public static final int VISIBLE_TEAM = 2;
    private int dynamicType;

    public abstract int getMapID();

    public abstract long getOwnerID();

    public abstract String getOwnerName();

    public abstract void load();

    public abstract void emptyProcess();

    public void unload() {
        this.unloadNpc();
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public long getSceneID() {
        return this.sceneId;
    }

    void setSceneID(long sceneID) {
        this.sceneId = sceneID;
    }

    boolean equals(Scene o) {
        if (null == o) {
            return false;
        }
        return this.sceneId == o.sceneId;
    }

    public MapInfo getMapInfo() {
        return this.mapInfo;
    }

    void setMapInfo(MapInfo info) {
        this.mapInfo = info;
    }

    public int getHighth() {
        return this.mapInfo.getBlockInfo().getHighth();
    }

    public int getWidth() {
        return this.mapInfo.getBlockInfo().getWidth();
    }

    public int getScreenWidth() {
        return this.getWidth() / 56;
    }

    public int getScreenHighth() {
        return this.getHighth() / 56;
    }

    public boolean checkBlock(GridPos grid, short blockType) {
        return this.mapInfo.getBlockInfo().checkBlock(grid, blockType);
    }

    public boolean checkBlock(Position pos, short blockType) {
        return this.mapInfo.getBlockInfo().checkBlock(pos, blockType);
    }

    public boolean checkBaitan(GridPos grid) {
        return this.mapInfo.getBlockInfo().checkBaitan(grid);
    }

    public boolean checkChannel(Position pos) {
        return this.checkBlock(pos.toGridPos(), (short)4);
    }

    public GotoInfo getGotoInfo(GridPos grid) {
        return this.mapInfo.getBlockInfo().getGotoInfo(grid.getX(), grid.getY());
    }

    public final Map<Long, Role> getSceneRoles() {
        HashMap<Long, Role> retMap = new HashMap<Long, Role>();
        for (Screen sc : this.screens.values()) {
            retMap.putAll(sc.getAllRoles());
        }
        return retMap;
    }

    public void sendAll(Protocol p2) {
        HashSet<Long> roleIDs = new HashSet<Long>();
        for (Role role : this.getSceneRoles().values()) {
            roleIDs.add(role.getRoleID());
        }
        Onlines.getInstance().send(roleIDs, p2);
    }

    public Map<Long, Role> getSpecialRolesInScreen(int index) {
        Screen s = this.screens.get(index);
        if (null == s) {
            return new HashMap<Long, Role>();
        }
        return s.getAllSpecialRoles();
    }

    public Map<Long, Role> getAllRolesInScreens(Set<Integer> indexs) {
        HashMap<Long, Role> roles = new HashMap<Long, Role>();
        for (int i : indexs) {
            Screen sc = this.screens.get(i);
            if (null == sc) continue;
            roles.putAll(sc.getAllRoles());
        }
        return roles;
    }

    public Map<Long, NPC> getAllNpcsInScreens(Set<Integer> indexs) {
        HashMap<Long, NPC> npcs = new HashMap<Long, NPC>();
        for (int i : indexs) {
            Screen sc = this.screens.get(i);
            if (null == sc) continue;
            npcs.putAll(sc.getNpcs());
        }
        return npcs;
    }

    public Map<Long, Pickup> getAllPickups() {
        HashMap<Long, Pickup> pickups = new HashMap<Long, Pickup>();
        List pickuplist = PickUpManager.getInstance().getPickupsInScene(this);
        for (Pickup p : pickuplist) {
            pickups.put(p.getUniqueID(), p);
        }
        return pickups;
    }

    public Map<Long, Pickup> getAllPickupsInScreens(Set<Integer> indexs) {
        HashMap<Long, Pickup> pickups = new HashMap<Long, Pickup>();
        List pickuplist = PickUpManager.getInstance().getPickupsInScreens(this, indexs);
        for (Pickup p : pickuplist) {
            pickups.put(p.getUniqueID(), p);
        }
        return pickups;
    }

    public Map<Long, NPC> getNpcsInScreen(int index) {
        Screen s = this.screens.get(index);
        if (null == s) {
            return new HashMap<Long, NPC>();
        }
        return s.getNpcs();
    }

    public ScreenPos getScreenPos(Position p) {
        int x = p.getX() / 896;
        int y = p.getY() / 896;
        int w = this.getScreenWidth();
        int h = this.getScreenHighth();
        x = x < w ? x : w - 1;
        y = y < h ? y : h - 1;
        return new ScreenPos(x, y);
    }

    public int getScreenIndex(Position p) {
        return this.getScreenPos(p).getScreenIndex();
    }

    public void removeBodyFromScreen(Body body) {
        int index = body.getMyScreenIndex();
        Screen s = this.screens.get(index);
        if (null == s) {
            SceneManager.logger.error((Object)("screen is null.mapid:" + this.getSceneID() + "index:" + index));
            return;
        }
        s.removeBody(body);
    }

    public void beginStall(Role role) {
        int index = role.getMyScreenIndex();
        Screen s = this.screens.get(index);
        if (null == s) {
            return;
        }
        s.addSpecial(role);
    }

    public void stopStall(Role role) {
        int index = role.getMyScreenIndex();
        Screen s = this.screens.get(index);
        if (null == s) {
            return;
        }
        s.removeSpecial(role);
    }

    public Map<Long, Role> getRoleInScreensByNum(Set<Integer> indexs, int num, Role role) {
        HashMap<Long, Role> map = new HashMap<Long, Role>();
        if (role != null && role.getTeam() != null) {
            for (Role mem : role.getTeam().getAllTeammates()) {
                if (mem == role || mem.getScene() != this || !indexs.contains(mem.getMyScreenIndex())) continue;
                map.put(mem.getRoleID(), mem);
            }
        }
        for (int i : indexs) {
            Screen s = this.screens.get(i);
            if (null == s) continue;
            for (Role stallrole : s.getAllSpecialRoles().values()) {
                if (role != null && stallrole.equals(role)) continue;
                map.put(stallrole.getRoleID(), stallrole);
            }
        }
        int stallnum = map.size();
        int sumnum = (int)Math.min(Integer.MAX_VALUE, (long)stallnum + (long)num);
        for (int i : indexs) {
            Screen s = this.screens.get(i);
            if (null == s) continue;
            for (Role c : s.getAllRoles().values()) {
                if (map.size() >= sumnum) {
                    return map;
                }
                if (role != null && c.equals(role) || c.isSpecialRole()) continue;
                map.put(c.getRoleID(), c);
            }
        }
        return map;
    }

    public Map<Long, Role> getRoleCannotSee(Set<Integer> indexes, int maxnum, Role role) {
        HashMap<Long, Role> notseeroles = new HashMap<Long, Role>();
        for (int index : indexes) {
            Screen s = this.getScreen(index);
            if (s == null) continue;
            for (Role r : s.getAllRoles().values()) {
                if (notseeroles.size() >= maxnum) {
                    return notseeroles;
                }
                if (role.getIcansee().containsKey(r.getRoleID()) || role == r) continue;
                notseeroles.put(r.getRoleID(), r);
            }
        }
        return notseeroles;
    }

    public void addBodyToScreen(Body body) {
        int screenIndex = body.getMyScreenIndex();
        Screen s = this.screens.get(screenIndex);
        if (null == s) {
            s = new Screen(screenIndex);
            this.screens.put(screenIndex, s);
        }
        s.addBody(body);
    }

    public Map<Long, NPC> getSceneNpcs() {
        HashMap<Long, NPC> map = new HashMap<Long, NPC>();
        for (Screen sc : this.screens.values()) {
            map.putAll(sc.getNpcs());
        }
        return map;
    }

    public boolean checkPath(List<Position> poslist, Position destPos, short blockType) {
        BlockInfo blockInfo = this.mapInfo.getBlockInfo();
        if (null == blockInfo) {
            return false;
        }
        if (blockInfo.checkTolerableBlock(destPos, blockType)) {
            return false;
        }
        poslist.add(destPos);
        return blockInfo.checkWay(poslist, blockType);
    }

    public Position checkAndChangeGotoPos(Position pos) {
        GridPos grid = pos.toGridPos();
        if (!this.validPosition(pos)) {
            grid = MapUtil.genPosInMap(this.getSceneID());
            if (grid == null) {
                return null;
            }
            pos = new Position(grid.toPosition().getX(), grid.toPosition().getY());
            LOG.error((Object)"进行跳转的位置已经超过地图宽度,自动转移到一个非阻挡点");
        }
        if (!this.checkBlock(pos, pos.getWalkBlockType())) {
            return pos;
        }
        grid = MapUtil.getNearestUnblockGridPos(this.getSceneID(), pos.toGridPos(), (short)1);
        if (grid == null) {
            return null;
        }
        LOG.error((Object)new StringBuilder().append("进行跳转的位置上有阻挡点,自动转移到最近的一个非阻挡点").append(",Mapid:").append((int)this.getSceneID()).append(",posx:").append(pos.toGridPos().getX()).append(",posy:").append(pos.toGridPos().getY()));
        return grid.toPosition();
    }

    public boolean validPosition(Position pos) {
        GridPos grid = pos.toGridPos();
        return grid.getX() >= 0 && grid.getY() >= 0 && grid.getX() < this.getWidth() && grid.getY() < this.getHighth();
    }

    protected void loadNpc() {
        if (null == this.mapInfo.getConfNpcList()) {
            return;
        }
        for (NpcDesc n : this.mapInfo.getConfNpcList()) {
            NPC npc;
            SNpcShare npcshare = (SNpcShare)ConfigManager.getInstance().getConf(SNpcShare.class).get(n.getid());
            if (npcshare == null) {
                LOG.error((Object)("我很抱歉~地图:" + this.getMapID() + ",NPC:" + n.getid() + "数据为null!"));
            }
            if (npcshare.getDiankafu() == 1 && Module.GetPayServiceType() == 0 || npcshare.getDiankafu() == 2 && Module.GetPayServiceType() == 1 || (npc = SceneNpcManager.getInstance().summonNpcAndUpdateGS(this, n)) != null) continue;
            LOG.error((Object)("加载NPC\t" + n.toString() + " 出错"));
        }
    }

    private void unloadNpc() {
        MRemoveNpcsFromGS snd = new MRemoveNpcsFromGS();
        for (NPC n : this.getSceneNpcs().values()) {
            SceneNpcManager.getInstance().delNpcWhileDestroyScene(n.getNpcKey());
            snd.npckeys.add(n.getNpcKey());
        }
        if (snd.npckeys.size() > 0) {
            SceneClient.pSend((Protocol)snd);
        }
    }

    public void onRoleEnter(Role r) {
        ++this.roleNum;
    }

    public void onRoleLeave(Role r) {
        int n = this.roleNum = this.roleNum > 0 ? this.roleNum - 1 : 0;
        if (0 == this.roleNum) {
            this.emptyProcess();
        }
    }

    public boolean isEmpty() {
        return this.roleNum == 0;
    }

    public String toString() {
        return "场景ID：" + this.sceneId + "，名称：" + this.name;
    }

    public int getDynamicType() {
        return this.dynamicType;
    }

    public void setDynamicType(int dynamicType) {
        this.dynamicType = dynamicType;
    }

    public Screen getScreen(int screenindex) {
        return this.screens.get(screenindex);
    }

    public MapConfig getMapConfig() {
        return this.mapcfg;
    }

    public void setMapConfig(MapConfig mapcfg) {
        this.mapcfg = mapcfg;
    }

    public int getWeatherId() {
        return -1;
    }

    public void setWeatherId(int weatherId) {
    }

    public String getWeatherParm() {
        return "";
    }
}

